MaxNumberOfTyresOut = 1
gOpacity            = 0.7        # 0.0 ... 1.0

'''
InvalidateLap App 0.1 for Assetto Corsa
for CSP v0.1.37 and later
'''
import ac, acsys
import sys, time, math
from sim_info import info

appWindow = 0
timer = 0
bInvalidated = False
noOuts = 0
noOutsCurrLap = 0
lastTime = 0.0
isOut = False
sAppError=""
lastLap = -2

def getAddenum(noOuts):
    if noOuts>0:
        return "\n   " + str(noOuts) + " cut(s) overall"
    return ""

def getAddenum2(noOutsCurrLap, currentLap):
    if noOutsCurrLap>0 and currentLap>0:
        return "\n   " + str(noOutsCurrLap) + " this lap"
    return ""

def CheckOffTrack():
    global MaxNumberOfTyresOut, lastLap, bInvalidated, appWindow
    global sAppError, info
    global noOuts, isOut, noOutsCurrLap, lastTime

    if sAppError!="":
        ac.setTitle(appWindow, sAppError)
    else:
        currentLap = ac.getCarState(0, acsys.CS.LapCount)
        # currentLap = info.graphics.numberOfLaps

        currentTime = ac.getCarState(0, acsys.CS.LapTime)
        if currentTime < lastTime:
            bInvalidated = False
            lastLap = currentLap
            isOut = False
            noOuts = 0
            noOutsCurrLap = 0
            ac.setSize(appWindow, 200, 25)
            lastTime = 0.0
        lastTime = currentTime

        if lastLap != currentLap:
            bInvalidated = False
            noOutsCurrLap = 0
            lastLap = currentLap
            if noOuts>0:
                ac.setSize(appWindow, 200, 50)
            else:
                ac.setSize(appWindow, 200, 25)

        CurrNumberOfTyresOut = info.physics.numberOfTyresOut
        if CurrNumberOfTyresOut >= MaxNumberOfTyresOut:
            if not isOut:
                isOut = True
                noOuts += 1
                noOutsCurrLap += 1
                if currentLap>0:
                    ac.setSize(appWindow, 200, 75)
                else:
                    ac.setSize(appWindow, 200, 50)
            if not bInvalidated:
                bInvalidated = True
                ac.ext_markLapAsSpoiled() # CSP function
            if CurrNumberOfTyresOut>1:
                ac.setTitle(appWindow," OFF track: " + str(CurrNumberOfTyresOut) + " wheels" + getAddenum(noOuts) + getAddenum2(noOutsCurrLap, currentLap))
            else:
                ac.setTitle(appWindow," OFF track: " + str(CurrNumberOfTyresOut) + " wheel"  + getAddenum(noOuts) + getAddenum2(noOutsCurrLap, currentLap))
        else:
            isOut = False
            addenum = ""
            if noOuts>0:
                addenum = "\n   " + str(noOuts) + " cut(s) already"
            ac.setTitle(appWindow," ON track" + getAddenum(noOuts) + getAddenum2(noOutsCurrLap, currentLap))

def acUpdate(deltaT):
    global timer, gOpacity
    timer += deltaT
    if timer > 0.05:
        timer = 0.0
        CheckOffTrack()
        ac.setBackgroundOpacity(appWindow, gOpacity)
        if gOpacity==0:
            ac.drawBorder(appWindow, 0)
        else:
            ac.drawBorder(appWindow, 1)

def acMain(ac_version):
    global appWindow, sAppError
    appWindow = ac.newApp("InvalidateLap")
    ac.setTitle(appWindow,"InvalidateLap")
    ac.setSize(appWindow, 200, 25)
    sAppError = ''
    try:
        sVerCode = ac.ext_patchVersionCode()
        if int(sVerCode)<=893: # version code for v0.1.36
            sAppError = str(ac.ext_patchVersion()) + ' CustomShaderPatch too old '
    except:
        sAppError = 'Shaders Patch not enabled or installed.'
    return "InvalidateLap"

def acShutdown(*args):
    pass
